Create Object Records
Create Object Records in bulk.
- The maximum input file size is 1GB.
- The values in the input must be UTF-8 encoded.
- CSVs must follow the standard format.
- The maximum batch size is 500.
Note that you can only add relationships on object fields using ID values or based on a unique field on the target object. This API does not support object lookup fields
/api/{version}/vobjects/{object_name}Headers
Section link for Headers| Name | Description |
|---|---|
Content-Type | text/csv or application/json |
Accept | application/json (default) or text/csv |
URI Path Parameters
Section link for URI Path Parameters| Name | Description |
|---|---|
{object_name} | The name of the object, for example, product__v. |
Body Parameters
Section link for Body ParametersUpload parameters as a JSON or CSV file.
| Name | Description |
|---|---|
name__v | This field is required unless it is set to system-managed. To find out if an object uses system-managed naming, retrieve its name__v field and look for the system_managed_name property set to true or false. Learn more about system-managed naming in Vault Help |
object_type__v | Optional: To create objects of a specific object type, add this field with the id of the object type. |
object_type__v.api_name__v | Optional: To create objects of a specific object type, add this field with the name of the object type. |
source_record_id | Optional: To copy an existing object record, add this field with the id of the existing object record. Any values specified for other fields will override the copied values. If you want to make a deep copy of a record, see the Deep Copy endpoint. |
Note that if object_type__v and object_type__v.api_name__v are both included, Vault creates the object with the type specified in object_type__v.
Query Parameters: Upsert Object Records
Section link for Query Parameters: Upsert Object RecordsUpsert is a combination of create and update. With idParam, you can identify an object record by any unique object field. This allows you to use one input file to create new object records and update existing records at the same time. If a matching record exists, Vault updates the record with the unique field values specified in the input. If no matching object record exists, Vault creates a new record using the values in the input.
Upsert expects unique idParam field values in the request and providing duplicate values will result in a FAILURE for the entire batch.
| Name | Description |
|---|---|
idParam | To upsert object records, add idParam={field_name} to the request endpoint. For example, idParam=external_id__v. Note that the specified object field must have unique set to true in the object metadata. |
Admin may set other standard or custom object fields to required. Use the Object Metadata API to retrieve all fields configured on objects. You can add any object field with editable: true.
Note that if an object has a field default configured, the value you use for that field overrides the default.
Request
Section link for Requestcurl -X POST -H "Authorization: {SESSION_ID}" \
-H "Content-Type: text/csv" \
-H "Accept: text/csv" \
--data-binary @"C:\Vault\Object Records\create_object_records.csv" \
https://myvault.veevavault.com/api/v17.1/vobjects/product__vResponse
Section link for Response{
"responseStatus": "SUCCESS",
"data": [
{
"responseStatus": "SUCCESS",
"data": {
"id": "0PR0771",
"url": "api/v8.0/vobjects/product__v/0PR0771"
}
},
{
"responseStatus": "SUCCESS",
"data": {
"id": "0PR0772",
"url": "api/v8.0/vobjects/product__v/0PR0772"
}
},
{
"responseStatus": "SUCCESS",
"data": {
"id": "0PR0773",
"url": "api/v8.0/vobjects/product__v/0PR0773"
}
},
{
"responseStatus": "FAILURE",
"errors": [
{
"type": "INVALID_DATA",
"message": "Error message describing why this object record was not created."
}
]
}
]
}